package com.ainur.morgoth.net.game.codec;

import com.ainur.morgoth.net.game.protocol.ServerMessage;
import io.netty.buffer.ByteBuf;
import io.netty.channel.ChannelHandlerContext;
import io.netty.handler.codec.MessageToByteEncoder;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 * Sends a message upstream to the client
 */
public class GameEncoder extends MessageToByteEncoder<ServerMessage> {
    private static final Logger logger = LoggerFactory.getLogger(GameEncoder.class.getName());

    @Override
    protected void encode(ChannelHandlerContext ctx, ServerMessage msg, ByteBuf out) throws Exception {
        if (ctx.channel().isActive()) {
            out.writeBytes(msg.getBuffer().duplicate());

            logger.debug(msg.toString());
        }
    }
}