package com.ainur.morgoth.net.game.codec;

import io.netty.buffer.ByteBuf;
import io.netty.channel.ChannelFutureListener;
import io.netty.channel.ChannelHandlerContext;
import io.netty.handler.codec.ByteToMessageDecoder;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.util.List;

/**
 * Used to parse a flash policy request
 */
public class PolicyDecoder extends ByteToMessageDecoder {
    private String policyFile;

    public PolicyDecoder(String policyFile) {
//        this.policyFile = policyFile;
        this.policyFile =   "<?xml version=\"1.0\"?>\r\n"
                + "<!DOCTYPE cross-domain-policy SYSTEM \"/xml/dtds/cross-domain-policy.dtd\">\r\n"
                + "<cross-domain-policy>\r\n"
                + "<allow-access-from domain=\"*\" to-ports=\"*\" />\r\n"
                + "</cross-domain-policy>\0";
    }

    @Override
    protected void decode(ChannelHandlerContext ctx, ByteBuf in, List<Object> out) throws Exception {
        in.markReaderIndex();
        if(in.readableBytes() < 1) return;

        byte delimiter = in.readByte();

        in.resetReaderIndex();

        if (delimiter == 0x3C) {
            ctx.channel().writeAndFlush(policyFile).addListener(ChannelFutureListener.CLOSE);
        } else {
            ctx.channel().pipeline().remove(this);

            GameDecoder decoder = ctx.pipeline().get(GameDecoder.class);
            decoder.decode(ctx, in, out);
        }
    }
}