package com.ainur.morgoth.net.game.sessions;

import com.ainur.morgoth.net.game.protocol.ClientMessage;
import com.ainur.morgoth.net.game.protocol.ServerMessage;
import io.netty.channel.Channel;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.net.InetSocketAddress;

/**
 * Created by Jordan on 27/03/15.
 */
public class GameSession {
    private static Logger logger = LoggerFactory.getLogger(GameSession.class);
    private final long id;
    private Channel channel;
    private String ipAddress;
    private boolean ponged;

    public GameSession(long id, Channel channel) {
        this.id = id;
        this.channel = channel;
        this.ipAddress = ((InetSocketAddress) this.channel.remoteAddress()).getAddress().toString().substring(1);
        this.ponged = true;
    }

    public Channel getChannel() {
        return channel;
    }

    public long getId() {
        return id;
    }

    public String getIpAddress() {
        return ipAddress;
    }

    public boolean isPonged() {
        return ponged;
    }

    public void setPonged(boolean ponged) {
        this.ponged = ponged;
    }

    public boolean hasPonged() {
        return ponged;
    }

    public void sendMessage(ServerMessage message) {
        this.channel.write(message);
    }

    public void broadcast(ServerMessage message) {
        this.channel.write(message.getBuffer().duplicate());
    }

    public void handleMessage(ClientMessage message) {
//        MessageHandler.invoke(this, message);
    }

}
