package com.ainur.morgoth.net.game.sessions;

import gnu.trove.map.hash.THashMap;
import io.netty.channel.Channel;
import io.netty.util.AttributeKey;

import java.util.Map;
import java.util.concurrent.atomic.AtomicLong;

/**
 * Created by Leon on 18/04/2015.
 */
public class GameSessionManager {
    public static final AttributeKey<Long> SESSION_ID_ATTR = AttributeKey.valueOf("ChannelId.attr");

    private final Map<Long, GameSession> sessions;
    private final AtomicLong sessionIdGenerator;

    public GameSessionManager() {
        this.sessions = new THashMap<>();
        this.sessionIdGenerator = new AtomicLong();
    }

    public GameSession addConnection(Channel channel) {
        final GameSession gameSession = new GameSession(this.sessionIdGenerator.incrementAndGet(), channel);

        channel.attr(SESSION_ID_ATTR).setIfAbsent(gameSession.getId());
        sessions.put(gameSession.getId(), gameSession);

        return gameSession;
    }

    public void removeConnection(Long sessionId) {
        // TODO: trigger onPlayerDisconnect event or whatever

        this.sessions.remove(sessionId);
    }

    public GameSession getSessionById(Long sessionId) {
        return this.sessions.get(sessionId);
    }
}
